@using Entities
@using Business
@using DataAccess

@inject IDbContextFactory<inventory_context> ContextFactory;
@inject NavigationManager navManager

@if (DataLoading)
{
    <h5>Data is loading ...</h5>
}

<div>
    <EditForm Model="oProduct">
        <div class="form-group">
            <label for="">Referencia:</label>
            <InputText @bind-Value="oProduct.ProdCode" class="form-control" />
        </div>
        <br>
        <div class="form-group">
            <label for="">Nombre del Producto:</label>
            <InputText @bind-Value="oProduct.ProdName" class="form-control" />
        </div>
        <br>
        <div class="form-group">
            <label for="">Descripcion del Producto:</label>
            <InputTextArea @bind-Value="oProduct.ProdDescription" class="form-control" />
        </div>
        <br>

        <div class="form-group">
            <label for="">Categoria:</label>
            <InputSelect @bind-Value="oProduct.CatId" class="form-control">
                @foreach (var category in categories)
                {
                    <option value="none" selected disabled hidden>Elige una Categoria ..</option>
                    <option value="@category.CatId">@category.CatName</option>
                }
            </InputSelect>
        </div>
        <br>

        <input type="button" value="Agregar Producto" @onclick="SaveProduct">
            
    </EditForm>

</div>


@code {
    private bool DataLoading = false;
    Product oProduct = new();
    List<Category> categories = new();

    B_Product bProduct = null!;
    B_Category bCategory = null!;


    protected override async Task OnInitializedAsync()
    {
        if (DataLoading) 
        {
            return;
        }
        
        bProduct = new (ContextFactory);
        bCategory = new (ContextFactory);

        try
        {
            DataLoading = true; 
            categories = await bCategory!.GetCategories();            
        }
        catch (System.Exception ex)
        {
            throw ex;
        }
        finally
        {
            DataLoading = false;
        }
    }

    private async Task SaveProduct()
    {
        await bProduct!.CreateProduct(oProduct);
        oProduct = new ();

        navManager.NavigateTo("products/list");      
    }
}